import { useTheme } from '@mui/material';
import { ColorUtils } from '@nuskin/foundation-theme';
import { IconContainer } from './NsIcon.styled';
import IconVariants from './NsIconVariants';
import { NsIconProps } from './types.d';

const { paletteColor } = ColorUtils;
const NsIcon = ({
    name,
    size = 'large',
    color = 'primary',
    testId = 'icon',
    className,
    colorOverride,
}: NsIconProps) => {
    const Icon = IconVariants[name];
    const theme = useTheme();
    const iconColor = paletteColor(color)({ theme });
    if (!Icon) {
        return null;
    }

    return (
        <IconContainer data-testid={testId} size={size} className={className}>
            <Icon color={colorOverride ? colorOverride : (iconColor as any)} />
        </IconContainer>
    );
};

export default NsIcon;
